/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package pe.siso.horario.Services;

import java.util.ArrayList;
import pe.siso.horario.Beans.Aula;
import pe.siso.horario.DAO.AulaDAO;
import pe.siso.horario.DAO.DAOFactory;

/**
 *
 * @author fcelestino
 */
public class AulaServices {    
    DAOFactory fabrica = DAOFactory.getDAOFactory(DAOFactory.MYSQL);
    AulaDAO objAulaDAO= fabrica.getAulaDAO();
    
    public ArrayList<Aula> listaAulas(String codigoLocal,int inicio, int cantidad){
        ArrayList<Aula> lista=null;
        try {
            lista=objAulaDAO.listaAulas(codigoLocal, inicio, cantidad);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    
    public ArrayList<Aula> listaAulas(int inicio, int cantidad){
        ArrayList<Aula> lista=null;
        try {
            lista=objAulaDAO.listaAulas(inicio, cantidad);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    public ArrayList<Aula> listaAulas(){
        ArrayList<Aula> lista=null;
        try {
            lista=objAulaDAO.listaAulas();
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    
    
    public int registrarAula(String codSede,String codTipoCentro,String codCentro,String codNivel,String codTipoGrado,String codGrado,String codSeccion,String codTurno,String nombreAula,int codPeriodo){
        int dato=0;
        try {
            dato=objAulaDAO.registrarAula(codSede, codTipoCentro, codCentro, codNivel, codTipoGrado, codGrado, codSeccion, codTurno,nombreAula,codPeriodo);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return dato;
    }
    
    public String consultarAula(String codigoAula){
        String aula="";
        try {
            aula=objAulaDAO.consultarAula(codigoAula);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return aula;
    }
    public String consultarAulaSede(String codigoAula){
        String aula="";
        try {
            aula=objAulaDAO.consultarAulaSede(codigoAula);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return aula;
    }
		
		public String nombreCortoAula(String codigoAula){
		   String aula="";
        try {
            aula=objAulaDAO.nombreCortoAula(codigoAula);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return aula;
		}
		
		
    public Aula getAula(String codigoAula){
        Aula aula= new Aula();
        try {
            aula=objAulaDAO.getAula(codigoAula);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return aula;
    }
    
    public ArrayList<Aula> listaAulasEncuestadas(String codigoSede, String codigoEncuesta){
        ArrayList<Aula> lista=null;
        try {
            lista=objAulaDAO.listaAulasEncuestadas(codigoSede, codigoEncuesta);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    
    public int consultarAula(String codSede, String codTipoCentro, String codCentro, String codNivel, String codTipoGrado, String codGrado, String codSeccion, String codTurno){
        int dato=0;
        try {
            dato=objAulaDAO.consultarAula(codSede, codTipoCentro, codCentro, codNivel, codTipoGrado, codGrado, codSeccion, codTurno);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return dato;
    }
    public int consultarAulaConNombre(String codSede, String codTipoCentro, String codCentro, String codNivel, String codTipoGrado, String codGrado, String codSeccion, String codTurno,String nombre){
        int dato=0;
        try {
            dato=objAulaDAO.consultarAulaConNombre(codSede, codTipoCentro, codCentro, codNivel, codTipoGrado, codGrado, codSeccion, codTurno,nombre);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return dato;
    }
    
    public String cantidadUsuariosAula(){
        String cantidad="";
        try {
            cantidad=objAulaDAO.cantidadUsuariosAula();
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return cantidad;
    }
    
    public void crearUsuarioEncuestador(String codigoSede, String codigoAula, String nombreUsuario, String usuario, String clave,String cantidad){
        try {
            objAulaDAO.crearUsuarioEncuestador(codigoSede, codigoAula, nombreUsuario, usuario, clave, cantidad);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
    
    public ArrayList<Aula> listaAulasDirage(){
        ArrayList<Aula> lista=null;
        try {
            lista=objAulaDAO.listaAulasDirage();
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    
    public ArrayList<Aula> listaAulasDirage(String codigoLocal){
        ArrayList<Aula> lista=null;
        try {
            lista=objAulaDAO.listaAulasDirage(codigoLocal);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    
    public ArrayList<Aula> listarAulasBloque(String codSede, String codTipoCentro, String codCentro, String codNivel, String codTipoGrado, String codGrado, String codSeccion, String codTurno){
        ArrayList<Aula> lista=null;
        try {
            lista=objAulaDAO.listarAulasBloque(codSede, codTipoCentro, codCentro, codNivel, codTipoGrado, codGrado, codSeccion, codTurno);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    
    public ArrayList<Aula> listarAulasHorario(String codSede, String codTipoCentro, String codCentro, String codNivel, String codTipoGrado, String codGrado, String codSeccion, String codTurno,int inicio, int cantidad){
        ArrayList<Aula> lista=null;
        try {
            lista=objAulaDAO.listarAulasHorario(codSede, codTipoCentro, codCentro, codNivel, codTipoGrado, codGrado, codSeccion, codTurno, inicio,cantidad);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    public ArrayList<Aula> listarAulasHorario(String codSede, String codTipoCentro, String codCentro, String codNivel, String codTipoGrado, String codGrado, String codSeccion, String codTurno){
        ArrayList<Aula> lista=null;
        try {
            lista=objAulaDAO.listarAulasHorario(codSede, codTipoCentro, codCentro, codNivel, codTipoGrado, codGrado, codSeccion, codTurno);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    
    public ArrayList<Aula> reporteAulasHorario(String codSede){
        ArrayList<Aula> lista=null;
        try {
            lista=objAulaDAO.reporteAulasHorario(codSede);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    public ArrayList<Aula> reporteAulasHorario(String codSede,String codAula){
        ArrayList<Aula> lista=null;
        try {
            lista=objAulaDAO.reporteAulasHorario(codSede, codAula);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    
    public ArrayList<Aula> reporteAulasHorario(String codSede,int cantidad,int pagina){
        ArrayList<Aula> lista=null;
        try {
            lista=objAulaDAO.reporteAulasHorario(codSede, cantidad, pagina);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    
    public ArrayList<Aula> listaAulasDirage(String codigoLocal, int inicio, int cantitad){
        ArrayList<Aula> lista=null;
        try {
            lista=objAulaDAO.listaAulasDirage(codigoLocal, inicio, cantitad);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    
    public int CantlistaAulasDirageSede(String codigoLocal){
        int cant = 0;
        try {
            cant=objAulaDAO.CantlistaAulasDirageSede(codigoLocal);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return cant;
    }
    
    public ArrayList<Aula> listaAulasDirage(int inicio, int cantitad) {
        ArrayList<Aula> lista=null;
        try {
            lista=objAulaDAO.listaAulasDirage(inicio, cantitad);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }   
    public ArrayList<Aula> listarAulasBloque(String codSede, String codTipoCentro, String codCentro, String codNivel, String codTipoGrado, String codGrado, String codSeccion, String codTurno, int inicio, int cantidad)  {
        ArrayList<Aula> lista=null;
        try {
            lista=objAulaDAO.listarAulasBloque(codSede, codTipoCentro, codCentro, codNivel, codTipoGrado, codGrado, codSeccion, codTurno, inicio, cantidad);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }   
    public ArrayList<Aula> listarAulasBloqueTotal(String codSede, String codTipoCentro, String codCentro, String codNivel, String codTipoGrado, String codGrado, String codSeccion, String codTurno, int inicio, int cantidad,int codperiodo)  {
        ArrayList<Aula> lista=null;
        try {
            lista=objAulaDAO.listarAulasBloqueTotal(codSede, codTipoCentro, codCentro, codNivel, codTipoGrado, codGrado, codSeccion, codTurno, inicio, cantidad,codperiodo);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }   
    
    public int CantlistaAulasDirageSede(){
        int cant = 0;
        try {
            cant=objAulaDAO.CantlistaAulasDirageSede();
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return cant;
    }
    public int cantlistarAulasHorario(String codSede, String codTipoCentro, String codCentro, String codNivel, String codTipoGrado, String codGrado, String codSeccion, String codTurno){
        int cant = 0;
        try {
            cant=objAulaDAO.cantlistarAulasHorario(codSede, codTipoCentro, codCentro, codNivel, codTipoGrado, codGrado, codSeccion, codTurno);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return cant;
    }
    
    
    public int cantlistarAulasBloque(String codSede, String codTipoCentro, String codCentro, String codNivel, String codTipoGrado, String codGrado, String codSeccion, String codTurno)  {
        int cant = 0;
        try {
            cant=objAulaDAO.cantlistarAulasBloque(codSede, codTipoCentro, codCentro, codNivel, codTipoGrado, codGrado, codSeccion, codTurno);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return cant;
    }
    public int  cantidadreporteAulasHorario(String codSede) {
        int cant = 0;
        try {
            cant=objAulaDAO.cantidadreporteAulasHorario(codSede);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return cant;
    }
    public int  CantlistaAulas(String codSede) {
        int cant = 0;
        try {
            cant=objAulaDAO.CantlistaAulas(codSede);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
         
        return cant;
    }
    public int  CantlistaAulas() {
        int cant = 0;
        try {
            cant=objAulaDAO.CantlistaAulas();
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
       
        return cant;
    }
    
    public ArrayList<Aula> listarAulasHorario(String codSede, String codTipoCentro, String codCentro, String codNivel, String codTipoGrado, String codGrado, String codSeccion, String codTurno, String periodo){
        ArrayList<Aula> lista=null;
        try {
            lista=objAulaDAO.listarAulasHorario(codSede, codTipoCentro, codCentro, codNivel, codTipoGrado, codGrado, codSeccion, codTurno, periodo);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    
    public ArrayList<Aula> reporteAulasHorarioPeriodo(String codSede, String periodo, int pagina, int cantidad){
        ArrayList<Aula> lista=null;
        try {
            lista=objAulaDAO.reporteAulasHorarioPeriodo(codSede, periodo, pagina, cantidad);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    
    public ArrayList<Aula> reporteAulasHorarioPeriodo(String codSede, String periodo){
        ArrayList<Aula> lista=null;
        try {
            lista=objAulaDAO.reporteAulasHorarioPeriodo(codSede, periodo);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    
    public int cantidadreporteAulasHorario(String codSede, String periodo){
        int cant = 0;
        try {
            cant=objAulaDAO.cantidadreporteAulasHorario(codSede, periodo);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
       
        return cant;
    }
    
    public ArrayList<Aula> listarAula(String aulas, String periodo){
        ArrayList<Aula> lista=null;
        try {
            lista=objAulaDAO.listarAula(aulas, periodo);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    
    public ArrayList<Aula> listarDatosHorairo(String codSede, String periodo){
        ArrayList<Aula> lista=null;
        try {
            lista=objAulaDAO.listarDatosHorairo(codSede, periodo);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    
    public ArrayList<Aula> listarDatosHorairo(String periodo){
        ArrayList<Aula> lista=null;
        try {
            lista=objAulaDAO.listarDatosHorairo(periodo);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    
    public ArrayList<Aula> listarDatosHorairo2do(String periodo,String parte){
        ArrayList<Aula> lista=null;
        try {
            lista=objAulaDAO.listarDatosHorairo2do(periodo,parte);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    public ArrayList<Aula> listarAulaPorSede(int codSede,int periodo){
        ArrayList<Aula> lista=null;
        try {
            lista=objAulaDAO.listarAulaPorSede(codSede,periodo);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    
    public ArrayList<Aula> listadoAulas(String codigoSede, String codigoPeriodoAcademico){
        ArrayList<Aula> lista=null;
        try {
            lista = objAulaDAO.listadoAulas(codigoSede, codigoPeriodoAcademico);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return lista;
    }
		
		public int actualizarNombreAula(String codAula,String nomAula){
		  int dato=0; 
			try {
				dato=objAulaDAO.actualizarNombreAula(codAula,nomAula);
				
			} catch (Exception e) {
				e.printStackTrace();
			}
			return dato;
		}
    
    
}
